@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program is a simple demo of the CASEH and CASEI           *
'* statements.  When CASEH (the default) is in effect, then       *
'* the two values ABC and abc are not the same.  After a CASEI    *
'* statement is executed, ABC and abc are the same.  Mixed case   *
'* programming is a little more complicated than programming      *
'* when case is ignored, but not much.  BAX also has UCASE and    *
'* LCASE functions for converting from one case to another and of *
'* course you can simply ignore the whole business by making your *
'* beginning label all upper case which instructs BAX to convert  *
'* everything to upper case.                                      *
'*                                                                *
'* Note: Variables, labels and BAX keywords are all converted to  *
'* upper case by BAX's internal routines so these program elements*
'* are not case sensitive.                                        *
'******************************************************************
'
=aaa '************ lower case label means mixed case program ***********
caseh     'honor case when making comparisons
%u = ABC  'upper case value
%l = abc  'lower case value
'
output first, honor case when comparing %u and %l
if %u = %l then output values are equal else output values are not equal
output
'
casei     'ignore case when making comparisons
'
output now, ignore case when making the same comparison
if %u = %l then output values are equal else output values are not equal
output
'
END
:SKIPBAX
