@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program contains a sub-routine which will save the        *
'* list of values in the array %A1 -- %A2 -- %A3 -- etc to any    *
'* array.  The root value of the array name is passed to the      *
'* sub-routine, so the same sub-routine can be used as many times *
'* as necessary in a single program.  In the sample program, the  *
'* first call to SAVER1 specifies that the root variable name is  *
'* BOYS.  Values will be saved in %BOYS1 , %BOYS2, etc.  The      *
'* second call to SAVER1 specifies that the values are to be      *
'* saved in %GIRLS1 , %GIRLS2, etc.  Notice that in the SAVER1    *
'* sub-routine, neither %BOYS or %GIRLS appears.  The variable    *
'* names were dynamically created by the sub-routine, based on    *
'* the argument passed to it.  You can often do this with an      *
'* interpreter but you would have a deuce of a time doing it with *
'* a conventional compiled language.                              *
'*                                                                *
'* It's only fair to point out that although this is clever, it   *
'* also makes your program very "bug prone" because it is tough   *
'* to see what is going on simply by examining the code.          *
'*                                                                *
'******************************************************************
=AAAA                           ' BAX PROGRAM MUST START WITH A LABEL
'
IF %LA > 0 THEN GOTO =GOTSOME   ' USER ENTERED SOME ARGUMENTS
%DUMMY = LIT 10 20 30 40 50     ' OK, WE WILL HAVE TO MAKE SOME UP
%LA = PARSE %DUMMY              ' NOW WE HAVE SOME VALUES TO CHEW ON
'
=GOTSOME
'
CALL =SAVER1 BOYS               ' SAVE COMMAND LINE ARGS
'
CALL =SAVER1 GIRLS              ' SAVE THEM AGAIN TO A DIFFERENT VAR
'
'
CALL =DISPLAY                   ' DISPLAY THREE SETS OF VALUES
'
STOP                            ' TERMINATE PROGRAM
'
=SAVER1 %ZZ                     ' ROOT NAME OF VARIABLE PASSED TO US
%SV = 0                         ' INIT COUNTER
LOOP =SAV1                      ' TOP OF LOOP
%SV = ADD %SV 1                 ' INCREMENT COUNTER
IF %SV > %LA THEN LEAVE =SAV1   ' BEYOND LAST VALUE, BREAK LOOP
%XY = JOIN %ZZ %SV              ' CREATE THE VARIABLE NAME (NO % SIGN)
%%XY = %A%SV                    ' SAVE ARGUMENT
=SAV1                           ' BOTTOM OF LOOP
RETURN
'
=DISPLAY
'THE FOLLOWING LOOP DISPLAYS ALL THREE SETS OF VALUES TO SHOW THAT THE
'SUB-ROUTINE WORKED.
OUTPUT                           'BLANK LINE FOR COSMETIC EFFECT
%X = 0                           'INIT COUNTER
LOOP =SHOWEM                     'TOP OF LOOP
%X = ADD %X 1                    'BUMP COUNTER
IF %X > %LA THEN LEAVE =SHOWEM   'NO MORE, BREAK LOOP
OUTPUT %BOYS%X %GIRLS%X %A%X     'DISPLAY THREE SETS OF VALUES
=SHOWEM
RETURN
'
END                      'BAX PROGRAMS MUST END WITH AN END STATEMENT
:SKIPBAX
