@ECHO OFF
:START
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
IF ERRORLEVEL 100 GOTO START
IF ERRORLEVEL 1   GOTO SKIPBAX
IF NOT EXIST TEMPTEMP.BAT GOTO START
CALL TEMPTEMP
DEL TEMPTEMP.BAT
GOTO START
'
'******************************************************************
'*                                                                *
'*  SEE THE FILE PDOS.DOC FOR DOCUMENTATION ON THIS PROGRAM.      *
'*                                                                *
'******************************************************************
'
=PDOS                                  'UPPER CASE
'
%DRIVELIST = ABCDE                     '???? VALID DRIVE LETTERS ????
'
CALL =COLORSUB                         'SET UP NAMES FOR COLORS
%M = MONITOR                           'DO WE GOT COLOR ?
IF %M > 0 THEN COLORS %WHITEX %BLUE    'YUP, LET'S TRY EM
'
CLS                                    'CLEAR THE SCREEN
%CMDFLAG = 0                           'USE SHELL TO EXECUTE DOS CMDS
%ARROW = -->                           'WE APPEND THIS TO THE PROMPT
%BLANKLINE = RPT 80 %B                 'LINE OF BLANKS
'
=MYPROMPT                              'TOP OF OUR MAIN LOOP
'
%D = CURDIR                            'CURRENT DRIVE, DIRECTORY PATH
%PMSG = JOIN %D %ARROW                 'SET UP PROMPT STRING
%LM = LEN %PMSG                        'LENGTH OF PROMPT MSG
%LI = SUB 80 %LM                       'LENGTH OF INPUT FIELD
%TYPED = LEFT %BLANKLINE %LI           'FILL INPUT VARIABLE WITH BLANKS
IF %EOI = 0 THEN GOTO =BLANKIN         'BLANK INPUT LINE OK
'
%TYPED = JOIN %LASTTYPED %BLANKLINE    'REPEAT LAST COMMAND
%TYPED = LEFT %TYPED %LI               'TRIM IT TO PROPER LENGTH
'
=BLANKIN
CURSORVH 25 1                          'PUT CURSOR ON BOTTOM LINE
OUTMSG %PMSG                           'DISPLAY PROMPT
'
INPUT %TYPED                           'GET USERS INPUT FROM KEYBOARD
'
IF %EOI > 0 THEN GOTO =MYPROMPT        'ESCAPE KEY PRESSED
OUTPUT                                 'ADVANCE TO NEXT LINE
%TYPED = TRIM %TYPED                   'STRIP LEAD/TRAIL BLANKS
IF %TYPED = %N THEN GOTO =CLEAR        'CLEAR SCREEN ON NULL ENTRY
IF %TYPED = QUIT THEN STOP 1           'TERMINATE WITH ERRORLEVEL = 1
%LASTTYPED = %TYPED                    'SAVE LAST LINE TYPED
'
%L = LEN %TYPED                        'SEE IF WE HAVE IMPLIED DRIVE
IF %L > 1 THEN GOTO =OVER1             'NOPE, CAN ONLY BE ONE CHAR
%X = LOC %DRIVELIST %TYPED             'IS IT A DRIVE LETTER ?
IF %X > 0 THEN GOTO =IMPDR             'YES, CHANGE DRIVE
'
=OVER1
%LASTWORD = PARSE %TYPED               'SEPARATE CMD LINE INTO WORDS
%C = POS DR CD MD RD DEL DT DV BMV %A1 'SEE IF COMMAND IS ONE OF OURS
'
'IF COMMAND IS NOT ONE OF OURS, WE PASS IT TO COMMAND.COM
'
IF %C = 0 THEN GOTO =DOSCMD ELSE %L = JOIN = %A1  'MAKE LABEL
GOTO %L                                           'BRANCH TO OUR LABEL
'
=IMPDR '**************** IMPLIED DRIVE COMMAND ************
%A2 = %TYPED                            'MAKE IT LOOK LIKE CHDRIVE -
%LASTWORD = 2                           '- WAS ENTERED
'
=DR ' ******** CHDRIVE COMMAND ********
IF %LASTWORD <> 2 THEN GOTO =BADARGS    'GOTTA HAVE TWO WORDS
%TESTER = JOIN %A2 :\*.*                'TEST STRING
%J = EXIST %TESTER                      'SEE IF DRIVE EXISTS
IF %J = 1 THEN GOTO =BADARGS            'NOPE, ERROR
CHDRIVE %A2                             'CHANGE DRIVES
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=CD ' ********* CHDIR COMMAND ***********
IF %LASTWORD <> 2 THEN GOTO =BADARGS    'GOTTA HAVE TWO WORDS
%TESTER = JOIN %A2 \*.*                 'TEST STRING
%J = EXIST %TESTER                      'SEE IF DIRECTORY EXISTS
IF %J = 1 THEN GOTO =BADARGS            'NOPE, ERROR
CHDIR %A2                               'CHANGE DIRECTORY
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=MD ' ********* MKDIR COMMAND **********
IF %LASTWORD <> 2 THEN GOTO =BADARGS    'GOTTA HAVE TWO WORDS
%TESTER = JOIN %A2 \*.*                 'TEST STRING
%J = EXIST %TESTER                      'SEE IF DIRECTORY EXISTS
IF %J <> 1 THEN GOTO =BADARGS           'ALREADY EXISTS, ERROR
MKDIR %A2                               'CREATE THE DIRECTORY
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=RD '*********** RMDIR COMMAND ********
IF %LASTWORD <> 2 THEN GOTO =BADARGS    'GOTTA HAVE TWO WORDS
%TESTER = JOIN %A2 \*.*                 'TEST STRING
%J = EXIST %TESTER                      'SEE IF DIRECTORY EXISTS
IF %J = 1 THEN GOTO =BADARGS            'CAN'T FIND DIR, ERROR
IF %J = 0 THEN GOTO =BADARGS            'FOUND FILES, ERROR
RMDIR %A2                               'DELETE THE DIRECTORY
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=DEL ' ******** DEL COMMAND *********
IF %LASTWORD <> 2 THEN GOTO =BADARGS    'GOTTA HAVE TWO WORDS
DELETE %A2                              'DELETE THE FILE(S)
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=DT ' ********* DISPLAY DATE AND TIME *********
%X = NOW                                'GET TIME
OUTPUT THE DATE AND TIME ARE: %X        'DISPLAY THE DATE AND TIME
GOTO =MYPROMPT                          'BACK TO OUR PROMPT
'
=DV '************* DISPLAY DOS VERSION NUMBER ********************
%X = DOSVER
OUTPUT DOS VERSION NUMBER = %X
GOTO =MYPROMPT
'
=BMV '************* DISPLAY BAX MEMORY AND VARIABLE INFO *************
%X = MEMORY
OUTPUT %X
GOTO =MYPROMPT
'
=DOSCMD ' WE EITHER SHELL TO DOS OR WRITE A BAT FILE AND TERMINATE
IF %CMDFLAG > 0 THEN GOTO =CMDFILE
'
=SHELLOUT '******** PASS COMMAND TO DOS VIA SHELL ***********
CMD %TYPED      'PASS THE INPUT LINE TO DOS
GOTO =MYPROMPT  'BACK TO OUR PROMPT
'
=CMDFILE '********* PASS COMMAND(S) TO DOS VIA TEMPTEMP.BAT **********
'         THIS METHOD WILL NOT WORK UNLESS YOU HAVE AT LEAST DOS 3.30
'         BECAUSE IT IS DEPENDENT ON THE BATCH FILE CALL COMMAND
'
OPENOUT TEMPTEMP.BAT                 'OPEN OUTPUT FILE
OUTPUTF @ECHO OFF                    'SO DOS WON'T ECHO OUR COMMANDS
OUTPUTF %TYPED                       'WRITE COMMAND ON BAT FILE
CLOSEOUT                             'CLOSE OUTPUT FILE
STOP 0                               'TERMINATE WITH ERRORLEVEL 0
'
=CLEAR       '******** CLEAR SCREEN **********
CLS                                  'CLEAR THE SCREEN
GOTO =MYPROMPT                       'BACK TO OUR PROMPT
'
=BADARGS  '************************** OUTPUT ERROR MESSAGE ********
OUTPUT MISSING OR INVALID ARGUMENT(S)
GOTO =MYPROMPT                       'BACK TO OUR PROMPT
'
=COLORSUB         ' SUB-ROUTINE TO ASSIGN MEANINGFUL NAMES TO COLORS
'
%BLACK    =  0    ' NOTE: IF YOU ADD 8 TO ANY OF THESE YOU
%BLUE     =  1    ' WILL GET THE SAME COLOR, ONLY BRIGHTER.
%GREEN    =  2
%CYAN     =  3
%RED      =  4
%MAGENTA  =  5
%BROWN    =  6
%WHITE    =  7
'                  **** BRIGHTER COLORS ****
%GRAY     =  8     ' A BRIGHT BLACK IS GRAY
%BLUEX    =  9
%GREENX   = 10     ' BRIGHT COLORS MAY ONLY BE USED IN THE FOREGROUND
%CYANX    = 11
%REDX     = 12
%MAGENTAX = 13
%YELLOW   = 14     ' A BRIGHT BROWN IS YELLOW
%WHITEX   = 15
'
RETURN
'
END                                  'END OF BAX PROGRAM
:SKIPBAX
