@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program demonstrates the use of the FILELIST, FILENAME,   *
'* and FILEDATA routines.                                         *
'* This program displays all files in the current directory whose *
'* names end with a numeric character.  The file extension, if    *
'* present is ignored.                                            *
'*                                                                *
'******************************************************************
=AAA                                   'MUST BEGIN WITH A LABEL
FILELIST *.*                           'GENERATE INTERNAL LIST OF FILES
LOOP =FFF                              'TOP OF LOOP
%FN = FILENAME                         'GET NEXT FILE NAME FROM LIST
IF %FN = %N THEN LEAVE =FFF            'BREAK LOOP WHEN THERE ARE NO MORE
'
%WORK = %FN                            'WORKING COPY OF FILENAME.EXT
%I = LOC %WORK .                       'FIND PERIOD
'
IF %I = 0 THEN GOTO =NOEXT ELSE %I = SUB %I 1 'TEST FOR NO EXT
'
%WORK = LEFT %WORK %I                  'TRASH THE EXTENSION
=NOEXT
%C = RIGHT %WORK 1                     'GET LAST CHAR
%TVAL = LOC 1234567890 %C              'TEST FOR NUMERIC VALUE
IF %TVAL = 0 THEN GOTO =FFF            'NOT NUMERIC, SKIP IT
'
%FINFO = FILEDATA %FN                  'DATE -- TIME -- SIZE -- ATTRIB
%FN = LEFT %FN 12                      'PAD FILENAME TO LENGTH OF 12
OUTPUT %FN %FINFO                      'DISPLAY FILENAME AND DATA
=FFF                                   'LOOP BACK AND DO ANOTHER ONE
FILELIST                               'RELEASE FILELIST MEMORY
END                                    'TERMINATE OUR BAX PROGRAM
:SKIPBAX
